package sap.livelink365.callbacks.entity;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonSetter;

import java.sql.Timestamp;
import java.util.Date;

public class IncomingBody {

    public IncomingBody() {}

    public IncomingBody(String messageId, String message, String msisdn, String originatingAddress, Parameters parameters, ReceivedTime receivedTime) {
        this.messageId = messageId;
        this.message = message;
        this.msisdn = msisdn;
        this.originatingAddress = originatingAddress;
        this.parameters = parameters;
        this.receivedTime = receivedTime;
    }

    @JsonProperty
    private String messageId;

    @JsonProperty
    private String message;

    @JsonProperty
    private String msisdn;

    @JsonProperty
    private String originatingAddress;

    @JsonProperty
    private Parameters parameters;

    @JsonProperty
    private ReceivedTime receivedTime;

    public String getMessageId() {
        return messageId;
    }

    @JsonSetter("messageId")
    public void setMessageId(String messageId) {
        this.messageId = messageId;
    }

    public String getMessage() {
        return message;
    }

    @JsonSetter("message")
    public void setMessage(String message) {
        this.message = message;
    }

    public String getMsisdn() {
        return msisdn;
    }

    @JsonSetter("msisdn")
    public void setMsisdn(String msisdn) {
        this.msisdn = msisdn;
    }

    public String getOriginatingAddress() {
        return originatingAddress;
    }

    @JsonSetter("originatingAddress")
    public void setOriginatingAddress(String originatingAddress) {
        this.originatingAddress = originatingAddress;
    }

    public Parameters getParameters() {
        return parameters;
    }

    @JsonSetter("parameters")
    public void setParameters(Parameters parameters) {
        this.parameters = parameters;
    }

    public ReceivedTime getReceivedTime() {
        return receivedTime;
    }

    @JsonSetter("receivedTime")
    public void setReceivedTime(ReceivedTime receivedTime) {
        this.receivedTime = receivedTime;
    }


    public static class Code {
        @JsonProperty
        private String mcc;

        @JsonProperty
        private String mnc;

        public Code() {}

        public Code (String mcc, String mnc){
            this.mnc = mnc;
            this.mcc = mcc;
        }

        public String getMcc() {
            return mcc;
        }

        @JsonSetter("mcc")
        public void setMcc(String mcc) {
            this.mcc = mcc;
        }

        public String getMnc() {
            return mnc;
        }

        @JsonSetter("mnc")
        public void setMnc(String mnc) {
            this.mnc = mnc;
        }
    }

    public static class Operator {
        @JsonProperty
        private Code code;

        @JsonProperty
        private String standard;

        public Operator() {}

        public Operator (Code code, String standard){
            this.code = code;
            this.standard = standard;
        }

        public Code getCode() {
            return code;
        }

        @JsonSetter("code")
        public void setCode(Code code) {
            this.code = code;
        }

        public String getStandard() {
            return standard;
        }

        @JsonSetter("standard")
        public void setStandard(String standard) {
            this.standard = standard;
        }
    }

    public static class ReceivedTime {
        @JsonProperty
        private String Date;

        @JsonProperty
        private String Time;

        public ReceivedTime() {}

        public ReceivedTime(String Date, String Time){
            this.Date = Date;
            this.Time = Time;
        }

        public String getDate() {
            return Date;
        }

        @JsonSetter("Date")
        public void setDate(String date) {
            Date = date;
        }

        public String getTime() {
            return Time;
        }

        @JsonSetter("Time")
        public void setTime(String time) {
            Time = time;
        }
    }

    public static class Parameters {
        @JsonProperty
        private String accountId;

        @JsonProperty
        private String dcs;

        @JsonProperty
        private String keyword;

        @JsonProperty
        private String messageClass;

        @JsonProperty
        private String messageId;

        @JsonProperty
        private Operator operator;

        @JsonProperty
        private String receivedServiceNumber;

        @JsonProperty
        private ReceivedTime receivedTime;

        @JsonProperty
        private String udh;

        public Parameters() {}

        public Parameters(String accountId, String dcs, String keyword, String messageClass, String messageId, Operator operator, String receivedServiceNumber, ReceivedTime receivedTime, String udh) {
            this.accountId = accountId;
            this.dcs = dcs;
            this.keyword = keyword;
            this.messageClass = messageClass;
            this.messageId = messageId;
            this.operator = operator;
            this.receivedServiceNumber = receivedServiceNumber;
            this.receivedTime = receivedTime;
            this.udh = udh;
        }

        public String getAccountId() {
            return accountId;
        }

        @JsonSetter("accountId")
        public void setAccountId(String accountId) {
            this.accountId = accountId;
        }

        public String getDcs() {
            return dcs;
        }

        @JsonSetter("dcs")
        public void setDcs(String dcs) {
            this.dcs = dcs;
        }

        public String getKeyword() {
            return keyword;
        }

        @JsonSetter("keyword")
        public void setKeyword(String keyword) {
            this.keyword = keyword;
        }

        public String getMessageClass() {
            return messageClass;
        }

        @JsonSetter("messageClass")
        public void setMessageClass(String messageClass) {
            this.messageClass = messageClass;
        }

        public String getMessageId() {
            return messageId;
        }

        @JsonSetter("messageId")
        public void setMessageId(String messageId) {
            this.messageId = messageId;
        }

        public Operator getOperator() {
            return operator;
        }

        @JsonSetter("operator")
        public void setOperator(Operator operator) {
            this.operator = operator;
        }

        public String getReceivedServiceNumber() {
            return receivedServiceNumber;
        }

        @JsonSetter("receivedServiceNumber")
        public void setReceivedServiceNumber(String receivedServiceNumber) {
            this.receivedServiceNumber = receivedServiceNumber;
        }

        public ReceivedTime getReceivedTime() {
            return receivedTime;
        }

        @JsonSetter("receivedTime")
        public void setReceivedTime(ReceivedTime receivedTime) {
            this.receivedTime = receivedTime;
        }

        public String getUdh() {
            return udh;
        }

        @JsonSetter("udh")
        public void setUdh(String udh) {
            this.udh = udh;
        }
    }

}
