package sap.livelink365.callbacks.service;

import sap.livelink365.callbacks.entity.*;

import java.io.IOException;
import java.sql.Timestamp;
import java.time.Instant;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.time.format.DateTimeFormatter;
import java.util.Calendar;

public class AppointmentService {

    public AppointmentService() {};

    public void sendAppointmentMessage() throws IOException{
        Doctor doctor = new Doctor("1", "Christina", "Yang", "Cardiology");
        Person patient = new Person("2", "Steven", "Gorwell", "+50431401307");

        Calendar cal = Calendar.getInstance();
        cal.set(2018, 8, 18, 16, 30);

        Timestamp bookingDate = new Timestamp(cal.getTimeInMillis());

        Appointment appointment = new Appointment(doctor, patient, bookingDate);

        LocalDate date = Instant.ofEpochMilli(appointment.getDate().getTime()).atZone(ZoneId.systemDefault()).toLocalDate();
        LocalDateTime time = appointment.getDate().toLocalDateTime();

        String message = String.format("Mr/Ms %s, you have an appointment with Dr. %s (%s), schedule on %s at %s.",
                                       appointment.getPatient().getFullName(),
                                       appointment.getDoctor().getFullName(),
                                       appointment.getDoctor().getSpecialization(),
                                       date.format(DateTimeFormatter.ofPattern("E, dd-MM-u")),
                                       time.format(DateTimeFormatter.ofPattern("hh:mm a")));

        MessageService messageService = new MessageService();
        messageService.sendMessage(message, appointment.getPatient().getPhoneNumber(), "");
    }
}
