package sap.livelink365.callbacks.service;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
import sap.livelink365.callbacks.entity.IncomingBody;

@Service
public class IncomingService {

    protected final Logger logger = LoggerFactory.getLogger(getClass());

    public void receiveIncomingMessageCallback(IncomingBody incomingMessage) {
        logger.info(String.format("\nMessage Response for message order %s\nFrom Phone Number: %s\nResponse Text: %s\nOperator Standard: %s\nReceived on %s at %s",
                                  incomingMessage.getMessageId(),
                                  incomingMessage.getMsisdn(),
                                  incomingMessage.getMessage(),
                                  incomingMessage.getParameters().getOperator().getStandard(),
                                  incomingMessage.getReceivedTime().getDate(),
                                  incomingMessage.getReceivedTime().getTime()));
    }

}
